﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;
using Windows.Storage;
using SQLite.Net;
using SQLite.Net.Attributes;
using SQLite.Net.Platform.WinRT;
using SQLite.Net.Interop;
using static System.Diagnostics.Debug;

//“空白页”项模板在 http://go.microsoft.com/fwlink/?LinkId=402352&clcid=0x409 上有介绍

namespace App1
{
    /// <summary>
    /// 可用于自身或导航至 Frame 内部的空白页。
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();
        }

        private void OnClick(object sender, RoutedEventArgs e)
        {
            string fdlocal = ApplicationData.Current.LocalFolder.Path;
            string filename = "test.db";
            string dbfullpath = Path.Combine(fdlocal, filename);

            ISQLitePlatform platform = new SQLitePlatformWinRT();
            // 连接对象
            SQLiteConnection conn = new SQLiteConnection(platform, dbfullpath);
            WriteLine("db pathe: " + conn.DatabasePath);

            // 创建表
            int rn = conn.CreateTable<Student>(CreateFlags.None);
            WriteLine("create table res = {0}", rn);

            conn.Dispose();
        }

        private void OnInsert(object sender, RoutedEventArgs e)
        {
            string localFolder = ApplicationData.Current.LocalFolder.Path;
            string dbFullPath = Path.Combine(localFolder, "test.db");
            // 建立连接
            using (SQLiteConnection conn = new SQLiteConnection(new SQLitePlatformWinRT(), dbFullPath))
            {
                conn.DeleteAll<Student>();
                // 插入数据
                Student[] stus =
                {
                    new Student { Name="小王",Age = 21 },
                    new Student { Name = "小赵",Age=30 },
                    new Student {Name="小丁",Age=25 },
                    new Student {Name="小马",Age=27 }
                };
                int n = conn.InsertAll(stus);
                WriteLine($"已插入 {n} 条数据。");
            }
        }

        private void OnReadData(object sender, RoutedEventArgs e)
        {
            string localFolderPath = ApplicationData.Current.LocalFolder.Path;
            string dbFullpath = Path.Combine(localFolderPath, "test.db");

            using (SQLiteConnection conn = new SQLiteConnection(new SQLitePlatformWinRT(), dbFullpath))
            {
                // 获取列表
                TableQuery<Student> t = conn.Table<Student>();
                var q = from s in t.AsParallel<Student>()
                        orderby s.Age
                        select s;
                // 绑定
                lv.ItemsSource = q;
            }
        }
    }


    [Table("stu_info")]
    public class Student
    {
        [Column("id")]
        [PrimaryKey]
        [AutoIncrement()]
        public int ID { get; set; }

        [Column("name")]
        [NotNull]
        public string Name { get; set; }

        [Column("age")]
        public int Age { get; set; }
    }
}
